prereq.sh 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664
  1. #!/bin/sh
  2. # This file is part of the OpenADK project. OpenADK is copyrighted
  3. # material, please see the LICENCE file in the top-level directory.
  4. # resolve prerequisites for OpenADK build
  5. topdir=$(pwd)
  6. target="$@"
  7. flags="$MAKEFLAGS"
  8. out=0
  9. mirror=http://distfiles.openadk.org
  10. makever=4.1
  11. bashver=4.3.30
  12. # detect operating system
  13. os=$(env uname)
  14. osver=$(env uname -r)
  15. printf " ---> $os $osver for build detected.\n"
  16. # check if the filesystem is case sensitive
  17. rm -f foo
  18. echo >FOO
  19. if [ -e foo ]; then
  20. printf "ERROR: OpenADK cannot be built in a case-insensitive file system."
  21. case $os in
  22. CYG*)
  23. printf "Building OpenADK on $os needs a small registry change."
  24. printf "http://cygwin.com/cygwin-ug-net/using-specialnames.html"
  25. ;;
  26. Darwin*)
  27. printf "Building OpenADK on $os needs a case-sensitive disk partition."
  28. printf "For Snow Leopard and above you can use diskutil to resize your existing disk."
  29. printf "Example: sudo diskutil resizeVolume disk0s2 90G 1 jhfsx adk 30G"
  30. printf "For older versions you might consider to use a disk image:"
  31. printf "hdiutil create -type SPARSE -fs 'Case-sensitive Journaled HFS+' -size 30g ~/openadk.dmg"
  32. ;;
  33. esac
  34. rm -f FOO
  35. exit 1
  36. fi
  37. rm -f FOO
  38. # do we have a download tool?
  39. tools="curl wget"
  40. for tool in $tools; do
  41. printf " ---> checking if $tool is installed.. "
  42. if which $tool >/dev/null; then
  43. printf "found\n"
  44. case $tool in
  45. curl)
  46. FETCHCMD="$(which $tool) -L -k -f -s -o "
  47. ;;
  48. wget)
  49. FETCHCMD="$(which $tool) --no-check-certificate -q -O "
  50. ;;
  51. esac
  52. break
  53. else
  54. printf "not found\n"
  55. continue
  56. fi
  57. done
  58. if [ -z "$FETCHCMD" ]; then
  59. printf "ERROR: no download tool found. Fatal error.\n"
  60. exit 1
  61. fi
  62. # do we have a checksum tool?
  63. tools="sha256sum sha256 cksum shasum"
  64. for tool in $tools; do
  65. printf " ---> checking if $tool is installed.. "
  66. if which $tool >/dev/null 2>/dev/null; then
  67. printf "found\n"
  68. # check if cksum is usable
  69. case $tool in
  70. sha256sum)
  71. SHA256=$(which $tool)
  72. ;;
  73. sha256)
  74. SHA256="$(which $tool) -q"
  75. ;;
  76. cksum)
  77. if cksum -q >/dev/null 2>/dev/null; then
  78. SHA256="$(which $tool) -q -a sha256"
  79. else
  80. continue
  81. fi
  82. ;;
  83. shasum)
  84. SHA256="$(which $tool) -a 256"
  85. ;;
  86. esac
  87. break
  88. else
  89. printf "not found\n"
  90. continue
  91. fi
  92. done
  93. if [ -z "$SHA256" ]; then
  94. printf "ERROR: no checksum tool found. Fatal error.\n"
  95. exit 1
  96. fi
  97. # create download dir
  98. if [ ! -d $topdir/dl ]; then
  99. mkdir -p $topdir/dl
  100. fi
  101. # check for c compiler
  102. compilerbins="clang cc gcc"
  103. for compilerbin in $compilerbins; do
  104. printf " ---> checking if $compilerbin is installed.. "
  105. if which $compilerbin >/dev/null; then
  106. printf "found\n"
  107. CC=$compilerbin
  108. break
  109. else
  110. printf "not found\n"
  111. continue
  112. fi
  113. done
  114. # check for c++ compiler
  115. compilerbins="clang++ c++ g++"
  116. for compilerbin in $compilerbins; do
  117. printf " ---> checking if $compilerbin is installed.. "
  118. if which $compilerbin >/dev/null; then
  119. printf "found\n"
  120. CXX=$compilerbin
  121. break
  122. else
  123. printf "not found\n"
  124. continue
  125. fi
  126. done
  127. gnu_host_name=$(${CC} -dumpmachine)
  128. # relocation of topdir?
  129. olddir=$(grep "^ADK_TOPDIR" prereq.mk 2>/dev/null |cut -d '=' -f 2)
  130. newdir=$(pwd)
  131. if [ ! -z "$olddir" ]; then
  132. if [ "$olddir" != "$newdir" ]; then
  133. printf " ---> adk directory was relocated, fixing .."
  134. sed -i -e "s#$olddir#$newdir#g" $(find target_* -name \*.pc|xargs) 2>/dev/null
  135. sed -i -e "s#$olddir#$newdir#g" $(find host_${gnu_host_name} -type f|xargs) 2>/dev/null
  136. sed -i -e "s#$olddir#$newdir#g" $(find target_*/scripts -type f|xargs) 2>/dev/null
  137. sed -i -e "s#$olddir#$newdir#" target_*/etc/ipkg.conf 2>/dev/null
  138. sleep 2
  139. printf "done\n"
  140. fi
  141. fi
  142. case :$PATH: in
  143. (*:$topdir/host_${gnu_host_name}/bin:*) ;;
  144. (*) export PATH=$topdir/host_${gnu_host_name}/bin:$PATH ;;
  145. esac
  146. # check for GNU make
  147. makebins="gmake make"
  148. for makebin in $makebins; do
  149. printf " ---> checking if $makebin is installed.. "
  150. if which $makebin >/dev/null 2>/dev/null; then
  151. printf "found\n"
  152. printf " ---> checking if it is GNU make.. "
  153. $makebin --version 2>/dev/null| grep GNU >/dev/null
  154. if [ $? -eq 0 ]; then
  155. printf "yes\n"
  156. MAKE=$(which $makebin)
  157. break
  158. else
  159. # we need to build GNU make
  160. printf "no\n"
  161. printf " ---> compiling missing GNU make.. "
  162. cd dl
  163. $FETCHCMD make-${makever}.tar.gz $mirror/make-${makever}.tar.gz
  164. if [ $? -ne 0 ]; then
  165. printf "ERROR: failed to download make from $mirror\n"
  166. exit 1
  167. fi
  168. cd ..
  169. mkdir tmp
  170. cd tmp
  171. tar xzf ../dl/make-${makever}.tar.gz
  172. cd make-$makever
  173. ./configure --prefix=$topdir/host_$gnu_host_name/
  174. make
  175. make install
  176. cd ..
  177. cd ..
  178. rm -rf tmp
  179. MAKE=$topdir/host_$gnu_host_name/bin/make
  180. makebin=$topdir/host_$gnu_host_name/bin/make
  181. printf " done\n"
  182. fi
  183. else
  184. printf "not found\n"
  185. continue
  186. fi
  187. done
  188. # check for bash
  189. printf " ---> checking if bash is installed.. "
  190. if which bash >/dev/null; then
  191. printf "found\n"
  192. else
  193. # we need to build GNU bash
  194. printf "not found\n"
  195. printf " ---> compiling missing GNU bash.. "
  196. cd dl
  197. $FETCHCMD bash-${bashver}.tar.gz $mirror/bash-${bashver}.tar.gz
  198. if [ $? -ne 0 ]; then
  199. printf "ERROR: failed to download make from $mirror\n"
  200. exit 1
  201. fi
  202. cd ..
  203. mkdir tmp
  204. cd tmp
  205. tar xzf ../dl/bash-${bashver}.tar.gz
  206. cd bash-${bashver}
  207. ./configure --prefix=$topdir/host_$gnu_host_name/
  208. make
  209. make install
  210. cd ..
  211. cd ..
  212. rm -rf tmp
  213. printf " done\n"
  214. fi
  215. # skip the script if distclean / cleandir
  216. if [ "$target" = "distclean" -o "$target" = "cleandir" ]; then
  217. touch prereq.mk
  218. $makebin ADK_TOPDIR=$topdir -s -f Makefile.adk $flags $target
  219. exit 0
  220. fi
  221. printf " ---> checking if perl is installed.. "
  222. if ! which perl >/dev/null 2>&1; then
  223. echo You must install perl to continue.
  224. echo
  225. out=1
  226. printf "not found\n"
  227. fi
  228. printf "found\n"
  229. # creating prereq.mk
  230. echo "ADK_TOPDIR:=$(readlink -nf . 2>/dev/null || pwd -P)" > $topdir/prereq.mk
  231. echo "BASH:=$(which bash)" >> $topdir/prereq.mk
  232. echo "SHELL:=$(which bash)" >> $topdir/prereq.mk
  233. echo "GMAKE:=$MAKE" >> $topdir/prereq.mk
  234. echo "MAKE:=$MAKE" >> $topdir/prereq.mk
  235. echo "FETCHCMD:=$FETCHCMD" >> $topdir/prereq.mk
  236. echo "SHA256:=$SHA256" >> $topdir/prereq.mk
  237. echo "GNU_HOST_NAME:=${gnu_host_name}" >> $topdir/prereq.mk
  238. echo "OS_FOR_BUILD:=${os}" >> $topdir/prereq.mk
  239. echo "ARCH_FOR_BUILD:=$(${CC} -dumpmachine | sed \
  240. -e 's/x86_64-linux-gnux32/x32/' \
  241. -e s'/-.*//' \
  242. -e 's/sparc.*/sparc/' \
  243. -e 's/armeb.*/armeb/g' \
  244. -e 's/arm.*/arm/g' \
  245. -e 's/m68k.*/m68k/' \
  246. -e 's/sh[234]/sh/' \
  247. -e 's/mips-.*/mips/' \
  248. -e 's/mipsel-.*/mipsel/' \
  249. -e 's/i[3-9]86/x86/' \
  250. )" >>prereq.mk
  251. if [ "$CC" = "clang" ]; then
  252. echo "HOST_CC:=${CC} -fbracket-depth=1024" >> $topdir/prereq.mk
  253. else
  254. echo "HOST_CC:=${CC}" >> $topdir/prereq.mk
  255. fi
  256. if [ "$CXX" = "clang++" ]; then
  257. echo "HOST_CXX:=${CXX} -fbracket-depth=1024" >> $topdir/prereq.mk
  258. else
  259. echo "HOST_CXX:=${CXX}" >> $topdir/prereq.mk
  260. fi
  261. echo 'LANGUAGE:=C' >> $topdir/prereq.mk
  262. echo 'LC_ALL:=C' >> $topdir/prereq.mk
  263. echo "_PATH:=$PATH" >> $topdir/prereq.mk
  264. echo "PATH:=${topdir}/scripts:/usr/sbin:$PATH" >> $topdir/prereq.mk
  265. echo "GIT:=$(which git 2>/dev/null)" >> $topdir/prereq.mk
  266. echo "export ADK_TOPDIR GIT SHA256 BASH SHELL" >> $topdir/prereq.mk
  267. # check if compiler works
  268. cat >Makefile.tmp <<'EOF'
  269. include ${ADK_TOPDIR}/prereq.mk
  270. all: test
  271. test: test.c
  272. @${HOST_CC} ${HOST_CFLAGS} -o $@ $^ ${LDADD}
  273. EOF
  274. cat >test.c <<-'EOF'
  275. #include <stdio.h>
  276. int
  277. main()
  278. {
  279. printf("YES");
  280. return (0);
  281. }
  282. EOF
  283. $MAKE --no-print-directory ADK_TOPDIR=$topdir -f Makefile.tmp 2>&1
  284. X=$(./test)
  285. if [ $X != YES ]; then
  286. echo "$X" | sed 's/^/| /'
  287. echo Cannot compile a simple test programme.
  288. echo You must install a host make and C compiler.
  289. echo
  290. out=1
  291. fi
  292. rm test.c test Makefile.tmp 2>/dev/null
  293. # error out on any required prerequisite
  294. if [ $out -ne 0 ]; then
  295. exit $out
  296. fi
  297. host_build_bc=0
  298. if which bc >/dev/null 2>&1; then
  299. if ! echo quit|bc -q 2>/dev/null >/dev/null; then
  300. host_build_bc=1
  301. else
  302. if bc -v 2>&1| grep -q BSD >/dev/null 2>&1; then
  303. host_build_bc=1
  304. fi
  305. fi
  306. else
  307. host_build_bc=1
  308. fi
  309. host_build_bison=0
  310. if ! which bison >/dev/null 2>&1; then
  311. host_build_bison=1
  312. fi
  313. host_build_bzip2=0
  314. if ! which bzip2 >/dev/null 2>&1; then
  315. host_build_bzip2=1
  316. fi
  317. host_build_file=0
  318. if ! which file >/dev/null 2>&1; then
  319. host_build_file=1
  320. fi
  321. host_build_flex=0
  322. if ! which flex >/dev/null 2>&1; then
  323. host_build_flex=1
  324. fi
  325. host_build_m4=0
  326. if ! which m4 >/dev/null 2>&1; then
  327. host_build_m4=1
  328. fi
  329. host_build_mksh=0
  330. if ! which mksh >/dev/null 2>&1; then
  331. host_build_mksh=1
  332. fi
  333. host_build_patch=0
  334. if ! which patch >/dev/null 2>&1; then
  335. host_build_patch=1
  336. fi
  337. host_build_pkgconf=0
  338. if ! which pkgconf >/dev/null 2>&1; then
  339. host_build_pkgconf=1
  340. fi
  341. host_build_tar=0
  342. if which tar >/dev/null 2>&1; then
  343. if ! tar --version 2>/dev/null|grep GNU >/dev/null;then
  344. host_build_tar=1
  345. fi
  346. else
  347. host_build_tar=1
  348. fi
  349. host_build_findutils=0
  350. if which xargs >/dev/null 2>&1; then
  351. if ! xargs --version 2>/dev/null|grep GNU >/dev/null;then
  352. host_build_findutils=1
  353. fi
  354. fi
  355. if which find >/dev/null 2>&1; then
  356. if ! find --version 2>/dev/null|grep GNU >/dev/null;then
  357. host_build_findutils=1
  358. fi
  359. fi
  360. host_build_grep=0
  361. if which grep >/dev/null 2>&1; then
  362. if ! grep --version 2>/dev/null|grep GNU >/dev/null;then
  363. host_build_grep=1
  364. fi
  365. fi
  366. host_build_gawk=0
  367. if ! which gawk >/dev/null 2>&1; then
  368. host_build_gawk=1
  369. fi
  370. host_build_sed=0
  371. if which sed >/dev/null 2>&1; then
  372. if ! sed --version 2>/dev/null|grep GNU >/dev/null;then
  373. host_build_sed=1
  374. fi
  375. fi
  376. host_build_xz=0
  377. if ! which xz >/dev/null 2>&1; then
  378. host_build_xz=1
  379. fi
  380. # optional
  381. host_build_cdrtools=0
  382. if ! which mkisofs >/dev/null 2>&1; then
  383. host_build_cdrtools=1
  384. fi
  385. host_build_ccache=0
  386. if ! which ccache >/dev/null 2>&1; then
  387. host_build_ccache=1
  388. fi
  389. host_build_genext2fs=0
  390. if ! which genext2fs >/dev/null 2>&1; then
  391. host_build_genext2fs=1
  392. fi
  393. host_build_lzma=0
  394. if ! which lzma >/dev/null 2>&1; then
  395. host_build_lzma=1
  396. fi
  397. host_build_lz4=0
  398. if ! which lz4c >/dev/null 2>&1; then
  399. host_build_lz4=1
  400. fi
  401. host_build_lzop=0
  402. if ! which lzop >/dev/null 2>&1; then
  403. host_build_lzop=1
  404. fi
  405. host_build_qemu=0
  406. if ! which qemu-img >/dev/null 2>&1; then
  407. host_build_qemu=1
  408. fi
  409. host_build_coreutils=0
  410. if which tr >/dev/null 2>&1; then
  411. if ! tr --version 2>/dev/null|grep GNU >/dev/null;then
  412. host_build_coreutils=1
  413. fi
  414. fi
  415. echo "config ADK_HOST_BUILD_TOOLS" > $topdir/target/config/Config.in.prereq
  416. printf "\t%s\n" "bool" >> $topdir/target/config/Config.in.prereq
  417. printf "\t%s\n" "default y" >> $topdir/target/config/Config.in.prereq
  418. # always required
  419. if [ $host_build_bc -eq 1 ]; then
  420. printf "\t%s\n" "select ADK_HOST_BUILD_BC" >> $topdir/target/config/Config.in.prereq
  421. fi
  422. if [ $host_build_bison -eq 1 ]; then
  423. printf "\t%s\n" "select ADK_HOST_BUILD_BISON" >> $topdir/target/config/Config.in.prereq
  424. fi
  425. if [ $host_build_bzip2 -eq 1 ]; then
  426. printf "\t%s\n" "select ADK_HOST_BUILD_BZIP2" >> $topdir/target/config/Config.in.prereq
  427. fi
  428. if [ $host_build_file -eq 1 ]; then
  429. printf "\t%s\n" "select ADK_HOST_BUILD_FILE" >> $topdir/target/config/Config.in.prereq
  430. fi
  431. if [ $host_build_flex -eq 1 ]; then
  432. printf "\t%s\n" "select ADK_HOST_BUILD_FLEX" >> $topdir/target/config/Config.in.prereq
  433. fi
  434. if [ $host_build_gawk -eq 1 ]; then
  435. printf "\t%s\n" "select ADK_HOST_BUILD_GAWK" >> $topdir/target/config/Config.in.prereq
  436. fi
  437. if [ $host_build_grep -eq 1 ]; then
  438. printf "\t%s\n" "select ADK_HOST_BUILD_GREP" >> $topdir/target/config/Config.in.prereq
  439. fi
  440. if [ $host_build_m4 -eq 1 ]; then
  441. printf "\t%s\n" "select ADK_HOST_BUILD_M4" >> $topdir/target/config/Config.in.prereq
  442. fi
  443. if [ $host_build_mksh -eq 1 ]; then
  444. printf "\t%s\n" "select ADK_HOST_BUILD_MKSH" >> $topdir/target/config/Config.in.prereq
  445. fi
  446. if [ $host_build_patch -eq 1 ]; then
  447. printf "\t%s\n" "select ADK_HOST_BUILD_PATCH" >> $topdir/target/config/Config.in.prereq
  448. fi
  449. if [ $host_build_pkgconf -eq 1 ]; then
  450. printf "\t%s\n" "select ADK_HOST_BUILD_PKGCONF" >> $topdir/target/config/Config.in.prereq
  451. fi
  452. if [ $host_build_findutils -eq 1 ]; then
  453. printf "\t%s\n" "select ADK_HOST_BUILD_FINDUTILS" >> $topdir/target/config/Config.in.prereq
  454. fi
  455. if [ $host_build_sed -eq 1 ]; then
  456. printf "\t%s\n" "select ADK_HOST_BUILD_SED" >> $topdir/target/config/Config.in.prereq
  457. fi
  458. if [ $host_build_tar -eq 1 ]; then
  459. printf "\t%s\n" "select ADK_HOST_BUILD_TAR" >> $topdir/target/config/Config.in.prereq
  460. fi
  461. if [ $host_build_xz -eq 1 ]; then
  462. printf "\t%s\n" "select ADK_HOST_BUILD_XZ" >> $topdir/target/config/Config.in.prereq
  463. fi
  464. # optional
  465. if [ $host_build_ccache -eq 1 ]; then
  466. printf "\t%s\n" "select ADK_HOST_BUILD_CCACHE if ADK_HOST_NEED_CCACHE" >> $topdir/target/config/Config.in.prereq
  467. fi
  468. if [ $host_build_cdrtools -eq 1 ]; then
  469. printf "\t%s\n" "select ADK_HOST_BUILD_CDRTOOLS if ADK_HOST_NEED_CDRTOOLS" >> $topdir/target/config/Config.in.prereq
  470. fi
  471. if [ $host_build_genext2fs -eq 1 ]; then
  472. printf "\t%s\n" "select ADK_HOST_BUILD_GENEXT2FS if ADK_HOST_NEED_GENEXT2FS" >> $topdir/target/config/Config.in.prereq
  473. fi
  474. if [ $host_build_lzma -eq 1 ]; then
  475. printf "\t%s\n" "select ADK_HOST_BUILD_LZMA if ADK_HOST_NEED_LZMA" >> $topdir/target/config/Config.in.prereq
  476. fi
  477. if [ $host_build_lz4 -eq 1 ]; then
  478. printf "\t%s\n" "select ADK_HOST_BUILD_LZ4 if ADK_HOST_NEED_LZ4" >> $topdir/target/config/Config.in.prereq
  479. fi
  480. if [ $host_build_lzop -eq 1 ]; then
  481. printf "\t%s\n" "select ADK_HOST_BUILD_LZOP if ADK_HOST_NEED_LZOP" >> $topdir/target/config/Config.in.prereq
  482. fi
  483. if [ $host_build_qemu -eq 1 ]; then
  484. printf "\t%s\n" "select ADK_HOST_BUILD_QEMU if ADK_HOST_NEED_QEMU" >> $topdir/target/config/Config.in.prereq
  485. fi
  486. if [ $host_build_coreutils -eq 1 ]; then
  487. printf "\t%s\n" "select ADK_HOST_BUILD_COREUTILS if ADK_HOST_NEED_COREUTILS" >> $topdir/target/config/Config.in.prereq
  488. fi
  489. # create Host OS symbols
  490. case $os in
  491. Linux)
  492. printf "\nconfig ADK_HOST_LINUX\n" >> $topdir/target/config/Config.in.prereq
  493. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  494. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  495. ;;
  496. Darwin)
  497. printf "\nconfig ADK_HOST_DARWIN\n" >> $topdir/target/config/Config.in.prereq
  498. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  499. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  500. ;;
  501. OpenBSD)
  502. printf "\nconfig ADK_HOST_OPENBSD\n" >> $topdir/target/config/Config.in.prereq
  503. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  504. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  505. ;;
  506. FreeBSD)
  507. printf "\nconfig ADK_HOST_FREEBSD\n" >> $topdir/target/config/Config.in.prereq
  508. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  509. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  510. ;;
  511. NetBSD)
  512. printf "\nconfig ADK_HOST_NETBSD\n" >> $topdir/target/config/Config.in.prereq
  513. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  514. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  515. ;;
  516. MirBSD)
  517. printf "\nconfig ADK_HOST_MIRBSD\n" >> $topdir/target/config/Config.in.prereq
  518. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  519. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  520. ;;
  521. Cygwin*)
  522. printf "\nconfig ADK_HOST_CYGWIN\n" >> $topdir/target/config/Config.in.prereq
  523. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  524. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  525. ;;
  526. esac
  527. if [ "$target" = "defconfig" ]; then
  528. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  529. exit 0
  530. fi
  531. if [ ! -f $topdir/.config ]; then
  532. # create a config if no exist
  533. touch .firstrun
  534. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk menuconfig
  535. else
  536. # scan host-tool prerequisites of certain packages before building.
  537. . $topdir/.config
  538. if [ -n "$ADK_PACKAGE_KODI" ]; then
  539. NEED_JAVA="$NEED_JAVA kodi"
  540. fi
  541. if [ -n "$ADK_PACKAGE_ICU4C" ]; then
  542. NEED_STATIC_LIBSTDCXX="$NEED_STATIC_LIBSTDCXX icu4c"
  543. fi
  544. if [ -n "$ADK_PACKAGE_XKEYBOARD_CONFIG" ]; then
  545. NEED_XKBCOMP="$NEED_XKBCOMP xkeyboard-config"
  546. fi
  547. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_100DPI" ]; then
  548. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-100dpi"
  549. fi
  550. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_75DPI" ]; then
  551. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-75dpi"
  552. fi
  553. if [ -n "$ADK_PACKAGE_FONT_ADOBE_100DPI" ]; then
  554. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-100dpi"
  555. fi
  556. if [ -n "$ADK_PACKAGE_FONT_ADOBE_75DPI" ]; then
  557. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-75dpi"
  558. fi
  559. if [ -n "$NEED_MKFONTDIR" ]; then
  560. if ! which mkfontdir >/dev/null 2>&1; then
  561. printf "You need mkfontdir to build $NEED_MKFONTDIR"
  562. out=1
  563. fi
  564. fi
  565. if [ -n "$NEED_XKBCOMP" ]; then
  566. if ! which xkbcomp >/dev/null 2>&1; then
  567. printf "You need xkbcomp to build $NEED_XKBCOMP"
  568. out=1
  569. fi
  570. fi
  571. if [ -n "$NEED_JAVA" ]; then
  572. if ! which java >/dev/null 2>&1; then
  573. printf "You need java to build $NEED_JAVA"
  574. out=1
  575. fi
  576. fi
  577. if [ -n "$NEED_STATIC_LIBSTDCXX" ]; then
  578. cat >test.c <<-'EOF'
  579. #include <stdio.h>
  580. int
  581. main()
  582. {
  583. return (0);
  584. }
  585. EOF
  586. if ! $CXX -static-libstdc++ -o test test.c 2>/dev/null ; then
  587. printf "You need static version of libstdc++ installed to build $NEED_STATIC_LIBSTDCXX"
  588. out=1
  589. rm test test.c 2>/dev/null
  590. fi
  591. fi
  592. # error out
  593. if [ $out -ne 0 ]; then
  594. exit $out
  595. fi
  596. # start build
  597. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  598. fi